#include <MacHeaders68K>

#pragma pointers_in_D0		//	required for c-style toolbox glue function: c2pstr and p2cstr
							//	the inverse operation (pointers_in_A0) is performed at the end ...

//	Generate this as near code calls ...
#pragma near_code

// glue code for missing old Pascal functions ...
extern pascal void (UprString)(Str255 theString,Boolean diacSens);
pascal void (UpperString)(Str255 theString,Boolean diacSens)
{
    (UprString)(theString,diacSens);
}

// glue code for 'C' style toolbox calls ...

OSErr fsrename(char *oldName,short vRefNum,char *newName)
{
	Rename( c2pstr(oldName),  vRefNum,  c2pstr(newName));
	p2cstr((unsigned char *)oldName); p2cstr((unsigned char *)newName);
}

char *p2cstr(StringPtr aStr) 
{
	return (char *) P2CStr(aStr);
}

StringPtr c2pstr(char *aStr)
{
 	return C2PStr(aStr);
}

ControlHandle newcontrol(WindowPtr theWindow,const Rect *boundsRect,char *title,
    Boolean visible,short value,short min,short max,short procID,long refCon) 
{
	ControlHandle h = 
	NewControl(theWindow,boundsRect,c2pstr(title),visible,value,min,max,procID,refCon);
	p2cstr((StringPtr) title);
	return h;
}

void setcontroltitle(ControlHandle theControl, char *title)
{
	SetControlTitle(theControl,c2pstr(title));
	p2cstr((StringPtr) title);
}

void getcontroltitle(ControlHandle theControl, char *title)
{
	GetControlTitle(theControl,(StringPtr) title);
	p2cstr((StringPtr) title);
}

short testcontrol(ControlHandle theControl, Point *thePt)
{
	return TestControl(theControl,*thePt);
}

short findcontrol(Point *thePoint, WindowPtr theWindow, ControlHandle *theControl)
{
	return FindControl(*thePoint,theWindow,theControl);
}

short trackcontrol(ControlHandle theControl, Point *thePoint, ControlActionUPP actionProc)
{
	return TrackControl(theControl, *thePoint, actionProc);
}

void dragcontrol(ControlHandle theControl, Point *startPt, const Rect *limitRect, const Rect *slopRect, short axis)
{
	DragControl(theControl,*startPt, limitRect, slopRect, axis);
}

short opendeskacc(char *deskAccName)
{
	short s = OpenDeskAcc(c2pstr(deskAccName));
	p2cstr((StringPtr) deskAccName);
	return s;
}

OSErr opendriver(char *driverName, short *refNum)
{
	OSErr err = OpenDriver(c2pstr(driverName),refNum);
	p2cstr((StringPtr) driverName);
	return err;
}

DialogPtr newdialog(void *wStorage, const Rect *boundsRect, char *title, Boolean visible, short procID, WindowPtr behind, Boolean goAwayFlag, long refCon, Handle itmLstHndl)
{
	DialogPtr dp = NewDialog(wStorage,boundsRect,c2pstr(title),visible,procID,behind,goAwayFlag,refCon,itmLstHndl);
	
	p2cstr((StringPtr) title);
	return dp;
}

DialogPtr newcolordialog(void *dStorage, const Rect *boundsRect, char *title, Boolean visible, short procID, WindowPtr behind, Boolean goAwayFlag, long refCon, Handle items)
{
	DialogPtr dp = NewColorDialog(dStorage,boundsRect,c2pstr(title),visible,procID,behind,goAwayFlag,refCon,items);
	p2cstr((StringPtr) title);
	return dp;
}


void paramtext(char *param0, char *param1, char *param2, char *param3)
{
	ParamText(c2pstr(param0),c2pstr(param1),c2pstr(param2),c2pstr(param3));
	p2cstr((StringPtr) param0);p2cstr((StringPtr) param1);
	p2cstr((StringPtr) param2);p2cstr((StringPtr) param3);
}

void getdialogitemtext(Handle item, char *text)
{
	GetDialogItemText(item, (StringPtr) text);
	p2cstr((StringPtr) text);
}

void setdialogitemtext(Handle item, char *text)
{
	SetDialogItemText(item,c2pstr(text));
	p2cstr((StringPtr) text);
}

short finddialogitem(DialogPtr theDialog, Point *thePt)
{
	return FindDialogItem(theDialog, *thePt);
}

OSErr getvinfo(short drvNum, char *volName, short *vRefNum, long *freeBytes)
{
	OSErr err = GetVInfo(drvNum, (StringPtr) volName, vRefNum, freeBytes);
	p2cstr((StringPtr) volName);
	return err;
}

OSErr getvol(char *volName, short *vRefNum)
{
	OSErr err = GetVol((StringPtr) volName,vRefNum);
	p2cstr((StringPtr) volName);
	return err;
}


OSErr setvol(char *volName, short vRefNum)
{
	OSErr err = SetVol(c2pstr(volName),vRefNum);
	p2cstr((StringPtr) volName);
	return err;
}

OSErr flushvol(char *volName, short vRefNum)
{
	OSErr err = FlushVol(c2pstr(volName),vRefNum);
	p2cstr((StringPtr) volName);
	return err;
}

OSErr unmountvol(char *volName, short vRefNum)
{
	OSErr err = UnmountVol(c2pstr(volName),vRefNum);
	p2cstr((StringPtr) volName);
	return err;
}

OSErr eject(char *volName, short vRefNum)
{
	OSErr err = Eject(c2pstr(volName),vRefNum);
	p2cstr((StringPtr) volName);
	return err;
}

OSErr create(char *fileName, short vRefNum, OSType creator, OSType fileType)
{
	OSErr err = Create(c2pstr(fileName), vRefNum, creator, fileType);
	p2cstr((StringPtr) fileName);
	return err;
}

OSErr fsopen(char *fileName, short vRefNum, short *refNum)
{
	OSErr err = FSOpen(c2pstr(fileName),vRefNum,refNum);
	p2cstr((StringPtr) fileName);
	return err;
}

OSErr openrf(char *fileName, short vRefNum, short *refNum)
{
	OSErr err =OpenRF(c2pstr(fileName), vRefNum, refNum);
	p2cstr((StringPtr) fileName);
	return err;
}

OSErr getfinfo(char *fileName, short vRefNum, FInfo *fndrInfo)
{
	OSErr err = GetFInfo(c2pstr(fileName),vRefNum,fndrInfo);
	p2cstr((StringPtr) fileName);
	return err;
}

OSErr setfinfo(char *fileName, short vRefNum, FInfo *fndrInfo)
{
	OSErr err = SetFInfo(c2pstr(fileName), vRefNum, fndrInfo);
	p2cstr((StringPtr) fileName);
	return err;
}

OSErr setflock(char *fileName, short vRefNum)
{
	OSErr err = SetFLock(c2pstr(fileName),vRefNum);
	p2cstr((StringPtr) fileName);
	return err;
}

OSErr rstflock(char *fileName, short vRefNum)
{
	OSErr err = RstFLock(c2pstr(fileName),vRefNum);
	p2cstr((StringPtr) fileName);
	return err;
}

void getfontname(short familyID, char *theName)
{
	GetFontName(familyID,(unsigned char *)theName);
	p2cstr((StringPtr) theName);
}

void getfnum(char *theName, short *familyID)
{
	GetFNum(c2pstr(theName),familyID);
	p2cstr((StringPtr) theName);
}

void laddtocell(Ptr dataPtr, short dataLen, Cell *theCell, ListHandle lHandle)
{
	LAddToCell(dataPtr,dataLen, *theCell,lHandle);
}

void lcellsize(Point *cSize, ListHandle lHandle)
{
	LCellSize(*cSize, lHandle);
}

Boolean lclick(Point *pt, short modifiers, ListHandle lHandle)
{
	return LClick(*pt,modifiers, lHandle);
}

void lclrcell(Cell *theCell, ListHandle lHandle)
{
	LClrCell(*theCell, lHandle);
}

void ldraw(Cell *theCell, ListHandle lHandle)
{
	LDraw(*theCell, lHandle);
}

void lgetcelldatalocation(short *offset, short *len, Cell *theCell, ListHandle lHandle)
{
	LGetCellDataLocation(offset, len,*theCell, lHandle);
}

ListHandle lnew(Rect *rView, Rect *dataBounds, Point *cSize, short theProc, WindowPtr theWindow, Boolean drawIt, Boolean hasGrow, Boolean scrollHoriz, Boolean scrollVert)
{
	return LNew(rView,dataBounds,*cSize, theProc, theWindow, drawIt,hasGrow, scrollHoriz, scrollVert);
}

void lrect(Rect *cellRect, Cell *theCell, ListHandle lHandle)
{
	LRect(cellRect, *theCell, lHandle);
}

void lsetcell(Ptr dataPtr, short dataLen, Cell *theCell, ListHandle lHandle)
{
	LSetCell(dataPtr, dataLen,*theCell, lHandle);
}

void lsetselect(Boolean setIt, Cell *theCell, ListHandle lHandle)
{
	LSetSelect(setIt, *theCell, lHandle);
}

MenuHandle newmenu(short menuID, char *menuTitle)
{
	MenuHandle h = NewMenu(menuID,c2pstr(menuTitle));
	p2cstr((StringPtr) menuTitle);
	return h;
}

void appendmenu(MenuHandle menu, char *data)
{
	AppendMenu(menu,c2pstr(data));
	p2cstr((StringPtr) data);
}

long menuselect(Point *startPt)
{
	return MenuSelect(*startPt);
}

void setmenuitemtext(MenuHandle menu, short item, char *itemString)
{
	SetMenuItemText(menu,item,c2pstr(itemString));
	p2cstr((StringPtr) itemString);
}

void getmenuitemtext(MenuHandle menu, short item, char *itemString)
{
	GetMenuItemText(menu, item, (StringPtr) itemString);
	p2cstr((StringPtr) itemString);
}

void insertmenuitem(MenuHandle theMenu, char *itemString, short afterItem)
{
	InsertMenuItem(theMenu, c2pstr(itemString), afterItem);
	p2cstr((StringPtr) itemString);
}

short relstring(char *str1, char *str2, Boolean caseSens, Boolean diacSens)
{
	short s = RelString(c2pstr(str1), c2pstr(str2), caseSens, diacSens);
	p2cstr((StringPtr) str1); p2cstr((StringPtr) str2);
	return s;
}

void upperstring(char *theString, Boolean diacSens)
{
	UpperString(c2pstr(theString),diacSens);
	p2cstr((StringPtr) theString);
}

short iucompstring(char *aStr, char *bStr)
{
	short s = IUCompString(c2pstr(aStr), c2pstr(bStr));
	
	p2cstr((StringPtr) aStr); p2cstr((StringPtr) bStr);
	return s;
}

short iuequalstring(char *aStr, char *bStr)
{
	short s = IUEqualString(c2pstr(aStr), c2pstr(bStr));
	
	p2cstr((StringPtr) aStr); p2cstr((StringPtr) bStr);
	return s;
}

short iucomppstring(char *aStr, char *bStr, Handle intlHandle)
{
	short s = IUCompPString(c2pstr(aStr), c2pstr(bStr), intlHandle);
	p2cstr((StringPtr) aStr); p2cstr((StringPtr) bStr);
	return s;
}

short iuequalpstring(char *aStr, char *bStr, Handle intlHandle)
{
	short s = IUEqualPString(c2pstr(aStr), c2pstr(bStr),intlHandle);
	p2cstr((StringPtr) aStr); p2cstr((StringPtr) bStr);
	return s;
}	


short iustringorder(char *aStr, char *bStr, ScriptCode aScript, ScriptCode bScript, LangCode aLang, LangCode bLang)
{
	short s = IUStringOrder(c2pstr(aStr), c2pstr(bStr), aScript, bScript, aLang, bLang);
	p2cstr((StringPtr) aStr); p2cstr((StringPtr) bStr);
	return s;
}

void stringtonum(char *theString, long *theNum)
{
	StringToNum(c2pstr(theString), theNum);
	p2cstr((StringPtr) theString);
}

void numtostring(long theNum, char *theString)
{
    NumToString(theNum, c2pstr(theString));
    p2cstr((StringPtr) theString);
}

OSErr dibadmount(Point *where, long evtMessage)
{
	return DIBadMount(*where, evtMessage);
}

OSErr dizero(short drvnum, char *volName)
{
	OSErr err = DIZero(drvnum, c2pstr(volName));
	p2cstr((StringPtr) volName);
	return err;
}

void sfputfile(Point *where, char *prompt, char *origName, DlgHookUPP dlgHook, SFReply *reply)
{
	SFPutFile(*where, c2pstr(prompt), c2pstr(origName), dlgHook, reply);
	p2cstr((StringPtr) prompt); p2cstr((StringPtr) origName);
}

void sfpputfile(Point *where, char *prompt, char *origName, DlgHookUPP dlgHook, SFReply *reply, short dlgID, ModalFilterUPP filterProc)
{
	SFPPutFile(*where, c2pstr(prompt), c2pstr(origName),dlgHook,reply,dlgID,filterProc);
	p2cstr((StringPtr) prompt); p2cstr((StringPtr) origName);
}

void sfgetfile(Point *where, char *prompt, FileFilterUPP fileFilter, short numTypes, SFTypeList typeList, DlgHookUPP dlgHook, SFReply *reply)
{
	SFGetFile(*where, c2pstr(prompt),fileFilter,numTypes,typeList, dlgHook, reply);
	p2cstr((StringPtr) prompt);
}

void sfpgetfile(Point *where, char *prompt, FileFilterUPP fileFilter, short numTypes, SFTypeList typeList, DlgHookUPP dlgHook, SFReply *reply, short dlgID, ModalFilterUPP filterProc)
{
	SFPGetFile(*where, c2pstr(prompt),fileFilter, numTypes, typeList,dlgHook, reply, dlgID, filterProc);
	p2cstr((StringPtr) prompt);
}

void iudatestring(long dateTime, DateForm longFlag, char *result)
{
	IUDateString(dateTime, longFlag,(StringPtr) result);
	p2cstr((StringPtr) result);
}

void iutimestring(long dateTime, Boolean wantSeconds, char *result)
{
	IUTimeString(dateTime, wantSeconds, (StringPtr) result);
	p2cstr((StringPtr) result);
}

void iudatepstring(long dateTime, DateForm longFlag, char *result, Handle intlHandle)
{
	IUDatePString(dateTime,longFlag, (StringPtr) result, intlHandle);
	p2cstr((StringPtr) result);
}

void iutimepstring(long dateTime, Boolean wantSeconds, char *result, Handle intlHandle)
{
	IUTimePString(dateTime, wantSeconds, (StringPtr) result, intlHandle);
	p2cstr((StringPtr) result);
}

void iuldatestring(LongDateTime *dateTime, DateForm longFlag, char *result, Handle intlHandle)
{
	IULDateString(dateTime, longFlag, (StringPtr) result, intlHandle);
	p2cstr((StringPtr) result);
}

void iultimestring(LongDateTime *dateTime, Boolean wantSeconds, char *result, Handle intlHandle)
{
	IULTimeString(dateTime, wantSeconds, (StringPtr) result, intlHandle);
	p2cstr((StringPtr) result);
}

void drawstring(char *s)
{
	DrawString(c2pstr(s));
	p2cstr((StringPtr) s);
}

short stringwidth(char *s)
{
	short r = StringWidth(c2pstr(s));
	
	p2cstr((StringPtr) s);
	return r;
}

Boolean ptinrect(Point *pt, const Rect *r)
{
	return PtInRect(*pt, r);
}

void pt2rect(Point *pt1, Point *pt2, const Rect *destRect)
{
	Pt2Rect(*pt1, *pt2, (Rect *)destRect);
}

void pttoangle(const Rect *r, Point *pt, short *angle)
{
	PtToAngle(r, *pt, angle);
}

Boolean ptinrgn(Point *pt, RgnHandle rgn)
{
	return PtInRgn(*pt, rgn);
}

void addpt(Point *src, Point *dst)
{
	AddPt(*src, dst);
}

void subpt(Point *src, Point *dst)
{
	SubPt(*src, dst);
}

Boolean equalpt(Point *pt1, Point *pt2)
{
	return EqualPt(*pt1,*pt2);
}

void stuffhex(Ptr thingPtr, char *s)
{
	StuffHex(thingPtr, c2pstr(s));
	p2cstr((StringPtr) s);
}

void stdtext(short count, const void *textAddr, Point *numer, Point *denom)
{
	StdText(count, textAddr, *numer, *denom);
}

void stdline(Point *newPt)
{
	StdLine(*newPt);
}

void createresfile(char *fileName)
{
	CreateResFile(c2pstr(fileName));
	p2cstr((StringPtr) fileName);
}

short openresfile(char *fileName)
{
	short s =  OpenResFile(c2pstr(fileName));
	
	p2cstr((StringPtr) fileName);
	return s;
}

short openrfperm(char *fileName, short vRefNum, char permission)
{
	short s = OpenRFPerm(c2pstr(fileName), vRefNum, permission);
	
	p2cstr((StringPtr) fileName);
	return s;
}

Handle getnamedresource(ResType theType, char *name)
{
	Handle h = GetNamedResource(theType, c2pstr(name));
	
	p2cstr((StringPtr) name);
	return h;
}

Handle get1namedresource(ResType theType, char *name)
{
	Handle h = Get1NamedResource(theType, c2pstr(name));
	p2cstr((StringPtr) name);
	return h;
}

void getresinfo(Handle theResource, short *theID, ResType *theType, char *name)
{
	GetResInfo(theResource,theID, theType, c2pstr(name));
	p2cstr((StringPtr) name);
}

void setresinfo(Handle theResource, short theID, char *name)
{
	SetResInfo(theResource,theID,c2pstr(name));
	p2cstr((StringPtr) name);
}

void addresource(Handle theResource, ResType theType, short theID, char *name)
{
	AddResource(theResource, theType, theID, c2pstr(name));
	p2cstr((StringPtr) name);
}

void teclick(Point *pt, Boolean fExtend, TEHandle h)
{
	TEClick(*pt, fExtend, h);
}

void getindstring(char *theString, short strListID, short index)
{
	GetIndString((unsigned char *)theString, strListID, index);
	p2cstr((StringPtr) theString);
}

StringHandle newstring(char *theString)
{
	StringHandle h = NewString(c2pstr(theString));
	p2cstr((StringPtr) theString);
	return h;
}

void setstring(StringHandle theString, char *strNew)
{
	SetString(theString,c2pstr(strNew));
	p2cstr((StringPtr) strNew);
}

void shieldcursor(const Rect *shieldRect, Point *offsetPt)
{
	ShieldCursor(shieldRect,*offsetPt);
}

long deltapoint(Point *ptA, Point *ptB)
{
	return DeltaPoint(*ptA, *ptB);
}
	
WindowPtr newwindow(void *wStorage, const Rect *boundsRect, char *title, Boolean visible, short theProc, WindowPtr behind, Boolean goAwayFlag, long refCon)
{
	WindowPtr wp = NewWindow(wStorage, boundsRect, c2pstr(title), visible, theProc,behind, goAwayFlag, refCon);
	p2cstr((StringPtr) title);
	return wp;
}

WindowPtr newcwindow(void *wStorage, const Rect *boundsRect, char *title, Boolean visible, short procID, WindowPtr behind, Boolean goAwayFlag, long refCon)
{
	WindowPtr wp = NewCWindow(wStorage, boundsRect, c2pstr(title), visible, procID, behind, goAwayFlag, refCon);
	p2cstr((StringPtr) title);
	return wp;
}

void setwtitle(WindowPtr theWindow, char *title)
{
	SetWTitle(theWindow, c2pstr(title));
	p2cstr((StringPtr) title);
}

void getwtitle(WindowPtr theWindow, char *title)
{
	GetWTitle(theWindow, (StringPtr)  title);
	p2cstr((StringPtr) title);
}

short findwindow(Point *thePoint, WindowPtr *theWindow)
{
	return FindWindow(*thePoint,theWindow);
}

Boolean trackgoaway(WindowPtr theWindow, Point *thePt)
{
	return TrackGoAway(theWindow,*thePt);
}

void dragwindow(WindowPtr theWindow, Point *startPt, const Rect *boundsRect)
{
	DragWindow(theWindow, *startPt, boundsRect);
}

long growwindow(WindowPtr theWindow, Point *startPt, const Rect *bBox)
{
	return GrowWindow(theWindow, *startPt, bBox);
}

long pinrect(const Rect *theRect, Point *thePt)
{
	return PinRect(theRect, *thePt);
}

long draggrayrgn(RgnHandle theRgn, Point *startPt, const Rect *boundsRect, const Rect *slopRect, short axis, DragGrayRgnUPP actionProc)
{
	return DragGrayRgn(theRgn, *startPt, boundsRect, slopRect, axis, actionProc);
}

Boolean trackbox(WindowPtr theWindow, Point *thePt, short partCode)
{
	return TrackBox(theWindow, *thePt, partCode);
}

void getappparms(char *apName, short *apRefNum, Handle *apParam)
{
	GetAppParms(c2pstr(apName), apRefNum, apParam);
	p2cstr((StringPtr)apName);
}

#pragma pointers_in_A0
