//-------------------------  1994 by James G. Stout -------------------------------
// File		: cdef3D.h
// Date		: May 2, 1994
// Author	: Jim Stout
// Purpose	: A CDEF to implement some very simple 3D buttons
//			:
//			: This CDEF supports the System 7 style gray drawing of an
//			: inactive control and the useWindFont varCode.
//----------------------------------------------------------------------------------
#define togButProc 		0x04

#define EMBOSS	1
#define PUSHED	1
#define OFF		0

//----------------------------------------------------------------------------------
//	CDEF private data
//----------------------------------------------------------------------------------
typedef struct {
short	osVers;
short	txFont;
short	txSize;
}cdefData,**cdefHdl;

//----------------------------------------------------------------------------------
//	Function prototypes
//----------------------------------------------------------------------------------
static void doDraw				(ControlHandle cHdl, short varCode);
static void drawPush			(ControlHandle cHdl, short varCode, Boolean inColor, 
									Boolean bgInColor, short lnHt, short lnAdj);
static void drawCheck			(ControlHandle cHdl, short varCode, Boolean bgInColor);
static void drawRadio			(ControlHandle cHdl, short varCode, Boolean bgInColor);
static void drawTog				(ControlHandle cHdl, short varCode, Boolean bgInColor);
static void drawTitle			(ControlHandle cHdl, short varCode, short lnHt, 
									short lnAdj, Boolean emboss, Boolean pushed);
static void getNextLine			(Str255 t, Str255 s, short num);
static void frame3DRect			(ControlHandle theControl, Rect *rr, Boolean inColor);
static void frame3DCircle		(ControlHandle theControl, Rect *rr, Boolean inColor);


