//-------------------------  1994 by James G. Stout -------------------------------
// File		: cdefBar.h
// Date		: May 2, 1994
// Author	: Jim Stout
//			:
// Purpose	: header file for cdefBar.c
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
// variation codes	
//----------------------------------------------------------------------------------

#define vertBar	0x01
#define roundBar 0x02
#define barberPole 0x04

//----------------------------------------------------------------------------------
// control private data
//----------------------------------------------------------------------------------

typedef struct {
Pattern			thePat;
}cdefData,**cdefHdl;

	
//----------------------------------------------------------------------------------
//	Function prototypes
//----------------------------------------------------------------------------------

static void	drawRectBar			(ControlHandle theControl, short);
static void	drawRoundEndBar		(ControlHandle theControl, short);
static void frame3DRect			(Rect *rr, Boolean inColor);
static void frame3DRoundEndBar	(Rect *r, short diameter, Boolean inColor);
