#include <FCntl.h>

pascal short	NumToolboxTraps( void )
{
	if ( NGetTrapAddress(_InitGraf, ToolTrap) == NGetTrapAddress(0xAA6E, ToolTrap) )
		return 0x200;
	else
		return 0x400;
	
}

pascal TrapType GetTrapType( short theTrap )
{
	const short TrapMask = 0x0800;

	if ( (theTrap & TrapMask ) > 0 )
		return ToolTrap;
	else
		return OSTrap;
	
}
pascal Boolean TrapAvailable (short theTrap)
{
	TrapType	tType;
	
	tType = GetTrapType(theTrap);
	if ( tType ==ToolTrap )
	{
		theTrap = theTrap & 0x07FF;
		if ( theTrap >= NumToolboxTraps() )
			theTrap = _Unimplemented;
	}
	return NGetTrapAddress(theTrap, tType) != NGetTrapAddress(_Unimplemented, tType);
}
