/**********************************************************************
This is a good demonstration of how you might add defines.  If you add them 
within the else but after the include, they can be added to all of your source 
and you don't have to re-precompile.  See below.
**********************************************************************/

#pragma mpwc_newline on // on: '\n'==0x0D; off: '\n'==0x0A (default)
						//MacApp reqires it be on

#define	WantToPrecompile 0 //set to 1 if you want to precompile; 0 normally
#define wantDebugging 0 //this affects whether qDebug, qTheDebugger, etc get set
						//in MacAppHeaders.cp
#if WantToPrecompile

	#include <MacAppHeaders.cp>

#else

	#ifdef powerc
		#if wantDebugging
			#include <MacAppHeadersPPC_debug> 
		#else
			#include <MacAppHeadersPPC_nodebug> 
		#endif
	#else
		#if wantDebugging
			#include <MacAppHeaders68K_debug> 
		#else
			#include <MacAppHeaders68K_nodebug>
		#endif
	#endif
/*
#define		flag1 	1
#define		flag2	0
#include 	<MyApp.h>
#include 	<MyUtils.h>
...
*/
#endif