/************************************************************
 *
 *	Created: Tuesday, March 29, 1994 2:55:51 PM
 *	CFiller.h
 *	Definition of a dummy persistent object class
 *
 *
 *	Copyright  Neologic Systems 1992-1994. All Rights Reserved.
 *	All rights reserved
 *
 ***********************************************************/
#pragma once			/* Include this file only once */
#ifndef __CFiller__
#define __CFiller__ 1

#include CNeoPersistNativeH

const NeoID kFillerID			= 20;
enum {kFillerMaxLength			= 1024};
#define kFillerName	 			"\pCFiller"

class CFiller : public CNeoPersistNative
{
public:
	static CNeoPersist *New(void);
	virtual NeoID		getClassID(void) const;
	virtual long		getFileLength(void) const;

						/** I/O Methods **/
	virtual void		readObject(CNeoStream *aStream, const NeoTag aTag);
	virtual void		writeObject(CNeoStream *aStream, const NeoTag aTag);

						/** Variable Length Methods **/
	static long			GetLength(void) {return FFileLength;}
	static long			SetLength(const long aLength);

protected:
	static long			FFileLength;
};

#endif
