/************************************************************
 *
 *	Created: Tuesday, March 29, 1994 2:55:51 PM
 *	CFiller.cp
 *	Implementation of a dummy persistent object class
 *
 *
 *	Copyright  Neologic Systems 1992-1994. All Rights Reserved.
 *	All rights reserved
 *
 ***********************************************************/

#include "NeoTypes.h"
#include CNeoStreamH
#include "CFiller.h"

CNeoPersist *CFiller::New(void)
{
	return new CFiller();
}

NeoID CFiller::getClassID(void) const
{
	return kFillerID;
}

long CFiller::getFileLength(void) const
{
	return kNeoPersistFileLength + sizeof(fFiller);
}

#pragma segment NeoRead
void CFiller::readObject(CNeoStream *aStream, const NeoTag aTag)
{
	inherited::readObject(aStream, aTag);

	aStream->readString(fFiller, sizeof(fFiller));
}

#pragma segment NeoWrite
void CFiller::writeObject(CNeoStream *aStream, const NeoTag aTag)
{
	inherited::writeObject(aStream, aTag);

	aStream->writeString(fFiller, sizeof(fFiller));
}

