/***********************************************************************
  CNeoText.c

***********************************************************************/

#include "CNeoText.h"

/**********************************************************************

**********************************************************************/
void	CNeoText::INeoText(CView			*anEnclosure,
							CBureaucrat		*aSupervisor,
							short			aWidth,
							short			aHeight,
							short			aHEncl,
							short			aVEncl,
							SizingOption	aHSizing,
							SizingOption	aVSizing)
{
	CEditText::IEditText(anEnclosure, aSupervisor, aWidth, aHeight,
							aHEncl, aVEncl, aHSizing, aVSizing, 0);

	SetWholeLines( FALSE );
	SetWantsClicks( TRUE );
}

/**********************************************************************

**********************************************************************/
void	CNeoText::GetTextString(Str255  text)
{
	CharsHandle		theText;
	long			size;

	theText = (CharsHandle)GetTextHandle();
	size = GetHandleSize(theText);
	if (size > 254L)
		size = 254L;

	HLock(theText);
	BlockMove(*theText, &text[1], size);
	text[0] = (char)size;
	HUnlock(theText);

}