/****
 * CNDImagePICT.c
 *
 *	Methods for a persistent PICT image type.
  *  Copyright  1992 NeoLogic Systems.  All rights reserved.
*
 ****/

#include "NeoTypes.h"
#include "CNDImagePICT.h"

// Return the class ID for this kind of object
NeoID CNDImagePICT::getClassID(void) const
{
	return kNDImagePICTID;
}

/*
 * Allocate and initialize a new instance.
 */
CNeoPersist *CNDImagePICT::New(void)
{
	CNDImagePICT *	object;

	object = new CNDImagePICT;

	return object;
}

void CNDImagePICT::draw(Rect *aRect)
{
	PicHandle	pict;

	NeoFailNil(pict = (PicHandle)getBlob());

	DrawPicture(pict, aRect);
}

