/****
 * CNDImageTIFF.c
 *
 *	Methods for a persistent TIFF image type.
 *  Copyright  1992 NeoLogic Systems.  All rights reserved.
 *
 ****/

#include "NeoTypes.h"
#include "CNDImageTIFF.h"

// Return the class ID for this kind of object
NeoID CNDImageTIFF::getClassID(void) const
{
	return kNDImageTIFFID;
}

/*
 * Allocate and initialize a new instance.
 */
CNeoPersist *CNDImageTIFF::New(void)
{
	CNDImageTIFF *	object;

	object = new CNDImageTIFF;

	return object;
}

void CNDImageTIFF::draw(Rect *aRect)
{
	PicHandle	pict;

	NeoFailNil(pict = (PicHandle)getBlob());

	DrawPicture(pict, aRect);
}

