@echo off
! this is a simple program that lets you execute the MORE command with a wildcarded
! filename.
! Just type		MMORE name		to list the text file[s] identified by 'name'
!
! If you want to skip the rest of a file after the first page and continue with
! the next file, type cmd-period or cntl-C and then reply 'N' when asked whether
! you want to terminate the batch job.
!

	! check that there is a parameter
	if not "%1 " == " " goto CHECKED_LBL
		echo MMORE requires a parameter
		echo.
		goto DONE_LBL
:CHECKED_LBL

	! the next line is needed to skip files which are not of type 'TEXT'
	! without executing the PAUSE
	onerror CONTINUE_LBL
	for %filename in (%1) do begin
		more < %filename%
		echo -------------------------- "%filename%" completed ----------------------
		pause
	:CONTINUE_LBL
		next filename

	! let's clean up the environment
	set filename=
	
:DONE_LBL
