/************************************************************************/
/*	Project...:	Standard ANSI-C Library									*/
/*	Name......:	setjmp.h												*/
/*	Purpose...:	standard ANSI header file								*/
/*  Copyright.: Copyright 1994 by metrowerks inc. All rights reserved. */
/************************************************************************/

#ifndef __SETJMP__
#define __SETJMP__

#if __MWERKS__
#pragma options align=mac68k
#endif

#ifdef	powerc
typedef	long *jmp_buf[70];
#define	setjmp(jmp_buf)			__setjmp(jmp_buf)
#else
typedef long *jmp_buf[12];		//	D3-D7,PC,A2-A4,A6,SP,__local_destructor_chain
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifdef	powerc
int	__setjmp(jmp_buf);
void longjmp(jmp_buf,int);
#else
int setjmp(jmp_buf);
void longjmp(jmp_buf,int);
#endif
void __longjmp_ldestr(jmp_buf,int);

#ifdef __cplusplus
}
#endif

#if __MWERKS__
#pragma options align=reset
#endif

#endif
