
extern  diff_err discard_confusing_lines(struct file_data *filevec);
extern  int diff_2_files(struct file_data *filevec,int depth);
extern  void print_context_header(struct file_data *inf, int unidiff_flag);
extern  void print_context_script(struct change *script, int unidiff_flag);
extern  int specify_style(enum output_style style);
extern  int compare_files(char *dir0,char *name0,char *dir1,char *name1,int depth);
extern  int diff_dirs(char *name1,char *name2,
	int (*handle_file)(char *dir0,char *name0,
		char *dir1,char *name1,int depth),int depth, int nonex1, int nonex2);
extern  void print_ed_script(struct change *script);
extern  void pr_forward_ed_script(struct change *script);
extern  void print_ifdef_script (struct change *script);
extern  void print_rcs_script(struct change *script);
extern  diff_err find_and_hash_each_line(struct file_data *current);
extern  void find_identical_ends (struct file_data filevec[2]);
extern  int read_files(struct file_data *filevec);
extern  void print_normal_script(struct change *script);
extern  void print_normal_hunk(struct change *hunk);
extern  int re_set_syntax(int syntax);
extern  char *re_compile_pattern(char *pattern,int size,struct re_pattern_buffer *bufp);
extern  void re_compile_fastmap(struct re_pattern_buffer *bufp);
extern  char *re_comp(char *s);
extern  int re_exec(char *s);
extern  void perror_with_name(char *text);
extern  void pfatal_with_name(char *text);
extern  void error(/* char *format, */ ...);
extern  void fatal(char *message);
extern  void message(char *format,char *arg1,char *arg2);
extern  void print_message_queue(void );
extern  void setup_output(char *name0,char *name1,int depth);
extern  void finish_output(void );
extern  int line_cmp(struct line_def *s1,struct line_def *s2);
extern  struct change *find_change(struct change *start);
extern  struct change *find_reverse_change(struct change *start);
extern  void print_script(struct change *script,struct change *(*hunkfun)(struct change *start),void (*printfun)(struct change *hunk));
extern  void print_1_line(char *line_flag,struct line_def *line);
extern  int change_letter(LONG inserts,LONG deletes);
extern  LONG translate_line_number(struct file_data *file,LONG lnum);
extern  void translate_range(struct file_data *file,LONG a,LONG b,LONG *aptr,LONG *bptr);
extern  void print_number_range(int sepchar,struct file_data *file,LONG a,LONG b);
extern  void analyze_hunk(struct change *hunk,LONG *first0,LONG *last0,LONG *first1,LONG *last1,LONG *deletes,LONG *inserts);
extern  void *xmalloc(size_t size);
extern  void *xrealloc(void *old,size_t size);
extern  void *xcalloc(size_t nitems,size_t size);
extern  char *concat(char *s1,char *s2,char *s3);
extern  void debug_script(struct change *sp);

int	getopt(int nargc, char **nargv, const char *ostr);
	
int main_diff2(int argc, char *argv[]);
int	main_diff3 (int, char **);

void	resetopt(void);

int slurp (struct file_data *current);
int fprintf_outfile (const char *, ...);
int putc_outfile (int);
size_t fwrite_outfile (const void *, size_t, size_t);

/* We divided diff_2_files into two routines.  This way, the part which handles
 * reading the files can be handled separately. */
extern  struct change * diff_2_files_no_print (struct file_data *filevec, int *file_differs);
int print_results (struct file_data filevec[2], struct change *script,int depth);
void dispose_script (struct change *script);
int open_file_pair (struct file_data *inf, char *dir0, char *name0, char *dir1, char *name1);


