
struct	stat
	{
	long	st_ino;
	int	st_dev;
	time_t	st_mtime;
	long	st_size;
	long	st_mode;	/* These are a bunch of flags about the file */
	};

#define	S_IFMT	3	/* Mask for file "format" */
#define	S_IFDIR	1	/* This is one of the st_mode flags */
#define	S_IFREG	0	/* If (st_mode & S_IFMT) == S_IFREG, it is a regular file. */
#define	S_IFSTREAM	2	/* Standard input */

struct direct {
	char d_name[32];
};

typedef struct _dir {
	short	vRefNum;
	long	dirID;
	int totalCount;
	int	currCount;
	struct direct current;
} DIR;

int fstat (int fd, struct stat *theStat);
int stat (char *fileName, struct stat *theStat);

