/*****************************************************************************************
	 UMemory.More.CW
	 Mark Anderson
	 metrowerks
	 9/1/94
	 
	 This file is necessary for all builds of MacApp with CodeWarrior and provides
	 segment loading.  It is modeled after UMemory.a, a MacApp file.  If you have problems
	 with this file, please contact me at marka4@metrowerks.com.

*****************************************************************************************/
#ifndef __UMEMORY__
#include "UMemory.h"
#endif
//----------------------------------------------------------------------------------------
#pragma segment MAMemoryRes

pascal void PostLoadMacAppSegment();
#if !qPowerPC

asm pascal void ALoadMacAppSeg(void)
{
	fralloc
	movem.l    	D0-D2/A0-A2, -(A7)
	subq.w    	%0x4,A7
	move.l		0x20(A7), A0
	lea			SegNum,a1
	move.w		4(A0),(a1)
	move.w		4(A0), -(SP)
	jsr			LoadMacAppSegment;
	move.l		(A7)+, A0					
	pea			Table+2					// push a return address
											
	jmp			(A0)					// Call the original loadseg

		
Table:
	bra			ComeBack;
	dc.l		0;
SegNum:
	dc.w		0;
	dc.w		0;	//added to put the following jsr on a good boundary
ComeBack:
	jsr 		PostLoadMacAppSegment		// call back to Pascal again
	
	Sub.l		%2,4(A6)					// jerk our return address just like loadseg does
	movem.l    	(A7)+,D0-D2/A0-A2
	unlk       	A6
	rts							// We're outta here with A0 preserved
}

//----------------------------------------------------------------------------------------
asm pascal Boolean PreloadSegment(short theSegNum)
{
	fralloc
	movem.l    	D0-D2/A0-A2, -(A7)
	subq.w    	%0x2,A7
	
	move.w		theSegNum, -(SP)
	jsr			PreloadSegmentResource;
	move.b		(A7)+, D0					
	tst.b		D0
	bne.s		success;
	//segment didn't load
	
	clr.b		0x000A(A6)
	bra.s		done
	

success:
	subq.w    	%0x4,A7
	move.w		theSegNum, -(SP)
	lea			SegNum,a1
	move.w		theSegNum,(a1)
	jsr			LoadMacAppSegment;
	move.l		(A7)+, A0					

#if !qModelFarCode			//I have know idea what will happen with qModelFarCode set
	pea			Table+2					// push a return address
											
	jmp			(A0)					// Call the original loadseg

		
Table:
	bra			ComeBack;
	dc.l		0;
SegNum:
	dc.w		0;
	dc.w		0;	//added to put the following jsr on a good boundary
#endif
ComeBack:
	jsr 		PostLoadMacAppSegment		// call back to Pascal again
	
	move.b		%0x1, 0x000A(A6)
done:

	movem.l    	(A7)+,D0-D2/A0-A2
	frfree
	movea.l   	(A7)+,A0
	addq.w    	%0x2,A7
	jmp       	(A0)
}
#endif