//Changed to add debugging defines MEA 5/28/94
#pragma check_header_flags on

#define OBSOLETE                                //      CountAppFile() etc.

#ifndef FALSE
 #define FALSE 0
#endif
#ifndef TRUE
 #define TRUE 1
#endif

#define qMacApp 1

#ifdef powerc
 #define qPowerPC 1
#else
 #define qPowerPC 0
#endif

// System software requirements

#define qNeedsAppleEventMgr 1
#define qNeedsEditionMgr 1
#define qNeedsHelpMgr 1
#define qNeedsProcessMgr 1
#define qNeedsAliasMgr 1
#define qNeedsFolderMgr 1
#define qNeedsSystem7 1
#define SystemSevenOrLater 1

#define qNeedsColorQD 1

// Processor requirements

//__MC68881__ and __MC68020__ are set in the processor pane
#if __MC68881__ //remember that you won't be able to run the resulting app on a PPC if you set this
	#define qNeedsFPU   1
#else
	#define qNeedsFPU   0
#endif
#if __MC68020__
	#define qNeedsMC68020   1
#else
	#define qNeedsMC68020   0
#endif
#define qNeedsMC68030   0
#define qNeedsMC68040   0

//Do not define qModelFarCode even though you are using large model.  qModelFarCode is used 
//in UMemory.cp and UMemory.More.CW.cp (and UMemory.a).  These files are already tweaked to 
//support far code. Large Model (far code) is the only suggested method of compilation with CW.

// Template views support

#define qTemplateViews 1
#define qWriteTemplateViews 1

// Debugging support
#if wantDebugging	//wantDebugging is sort of one stop shopping for debugging
	#define qDebug 1
	#define qDebugMsg   1
	#define qNames  0 // The sample projects aren't set for Macsbug names
	#define qSym  1
	#define qTheDebugger  1
	#define qInspector  1
#ifdef powerc
	#define qPerform  0 //MPW's performance tools can't work with a PPC build
#else
	#define qPerform  1	//CW can use MPW's performance tools except when Jasik's debugger is
						//running under emulation.  Try it with Macsbug, MW Debug, SourceBug, 
						//or Jasik running on a 68K machine.  (The same limitation applies
						//when Jasik is used with a CFront build.)
#endif
	#define qRangeCheck   1

#else
	#define qDebug 0
	#define qDebugMsg   0
	#define qNames  0
	#define qSym  0
	#define qTheDebugger  0
	#define qInspector  0
	#define qPerform  0
	#define qRangeCheck   0
#endif

// Virtual user support

#define qNeedsVU   0




#pragma pointers_in_D0	//necessary because Apple and MA have some inlines that store 
						//directly in D0

#include <Aliases.h>
#include <AppleEvents.h>
#include <AppleTalk.h>
#include <Balloons.h>
#include <ConditionalMacros.h>
#include <Controls.h>
#include <Desk.h>
#include <Devices.h>
#include <Dialogs.h>
#include <Editions.h>
#include <Errors.h>
#include <Events.h>
#include <Files.h>
#include <Fonts.h>
#include <GestaltEqu.h>
#include <Icons.h>
#include <Lists.h>
#include <LowMem.h>
#include <Memory.h>
#include <Menus.h>
#include <MixedMode.h>
#include <OSEvents.h>
#include <OSUtils.h>
#include <Packages.h>
#include <Palettes.h>
#include <Picker.h>
#include <Printing.h>
#include <Processes.h>
#include <QDOffscreen.h>
#include <Quickdraw.h>
#include <QuickdrawText.h>
#include <Resources.h>
#include <Scrap.h>
#include <Script.h>
#include <StandardFile.h>
#include <TextEdit.h>
#include <TextUtils.h>
#include <ToolUtils.h>
#include <Traps.h>
#include <Windows.h>
#pragma pointers_in_A0	//necessary because Apple and MA have some inlines that store 
						//directly in D0

#include <stddef.h>
#include <limits.h>
#include <setjmp.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#if wantDebugging
	//CW currently can't output to stderr.  What follows is a kludge that puts the 
	//message in the debugger window.
	#undef fprintf
	#define fprintf	CWfprintf
	int CWfprintf(FILE * ignore, const char * format, ...);//defined in UFailure.cp

#endif

#if !USESCODEFRAGMENTS
extern pascal OSErr InitEditionPackVersion()
 FIVEWORDINLINE(0x3F3C, 0x0011, 0x303C, 0x0100, 0xA82D);
#endif

#if 1
        #include "ObjectHeap.h"
        #include "BestFitHeap.h"
        #include "Geometry.h"
        #include "MacAppTypes.h"
        #include "MemoryHeap.h"
        #include "NubInspectorHooks.h"
        #include "PascalString.h"
        #include "PlatformMemory.h"
        #include "Toolbox.h"
        #include "UAdorners.h"
        #include "UAppleEvents.h"
        #include "UApplication.h"
        #include "UAssociation.h"
        #include "UBehavior.h"
        #include "UBusyCursor.h"
        #include "UClassDesc.h"
        #include "UClassDescIterator.h"
        #include "UClipboardMgr.h"
        #include "UCommand.h"
        #include "UCommandHandler.h"
        #include "UControl.h"
        #include "UDebug.h"
        #include "UDependencies.h"
        #include "UDesignator.h"
        #include "UDeskScrapView.h"
        #include "UDialogBehavior.h"
        #include "UDocument.h"
        #include "UDrawingEnvironment.h"
        #include "UDynamicArray.h"
        #include "UErrorMgr.h"
        #include "UEvent.h"
        #include "UEventHandler.h"
        #include "UFailure.h"
        #include "UFile.h"
        #include "UFileBasedDocument.h"
        #include "UFileHandler.h"
        #include "UGeometry.h"
        #include "UIterator.h"
        #include "UList.h"
        #include "UListIterator.h"
        #include "ULoMem.h"
        #include "UMacAppGlobals.h"
        #include "UMacAppUtilities.h"
        #include "UMemory.h"
        #include "UMenuMgr.h"
        #include "Unmangler.h"
        #include "UObject.h"
        #include "UPatch.h"
        #include "UPointerObject.h"
        #include "UPopup.h"
        #include "UPrintHandler.h"
        #include "UScroller.h"
        #include "UStream.h"
        #include "UView.h"
        #include "UViewServer.h"
        #include "UWindow.h"
        
#if wantDebugging
        #include "CWFailure.h"
#endif

#endif
