/****
 * CNeoBenchDoc.h
 *
 *	Document class for a typical application.
 *
 ****/
#pragma once			/* Include this file only once */

#include CNeoPersistH
#include CNeoDocRootH

class CNeoBenchPane;

struct CNeoBenchDoc : public CNeoDocRoot {
public:
						CNeoBenchDoc(const Boolean aPrintable, const Boolean aNewDatabase, const Boolean aRemote);

	virtual void		buildWindow(void);
	virtual void		newDatabase(void);
	virtual void		ListenToMessage(MessageT aMessage, void *aParam);
	virtual void		openFile(FSSpec *aSpec);
};