/****
 * CImagePICT.h
 *
 *	Persistent PICT image class.
 *
 ****/

#pragma once			/* Include this file only once */
#include "CImage.h"

#define kImagePICTID		10

class CImagePICT : public CImage {
public:
						/** Instance Methods **/
	static CNeoPersist *New(void);
	virtual long		doUntilSubclass(NeoTestFunc1 aFunc, long aParam);

						/** Object List Methods **/
	virtual NeoID		getClassID(void);

						/** Rendering Methods **/
	virtual void		draw(Rect *aRect);
};

