/****
 * CNDImageTIFF.h
 *
 *	Persistent TIFF image class.
 *  Copyright  1992 NeoLogic Systems.  All rights reserved.
 *
 ****/

#pragma once			/* Include this file only once */
#include "CNDImage.h"

#define kNDImageTIFFID		24

class CNDImageTIFF : public CNDImage {
public:
						/** Instance Methods **/
	static CNeoPersist *New(void);
	virtual NeoID		getClassID(void) const;

						/** Rendering Methods **/
	virtual void		draw(Rect *aRect);
};

