/******************************************************************************
 CNeoDialogText.h

 		Interface for NeoDialogText class/


	SUPERCLASS =

	Copyright  1991 Symantec Corporation.	All rights reserved.
	Copyright  1992 NeoLogic Systems		All rights reserved.


 ******************************************************************************/

#define _H_CNeoDialogText

#include "CDialogText.h"

class CDialog;

class CNeoDialogText : public CDialogText
{
public:


	void 			INeoDialogText(CView *anEnclosure, CView *aSupervisor, short aWidth, short aHeight,
						short aHEncl, short aVEncl, SizingOption aHSizing, SizingOption aVSizing,
						short aLineWidth, Boolean aBorderVisible);
	void			DoClick(Point hitPt, short modifierKeys, long when);
	void			showBorder(const Boolean aShow);
	void			DoCommand(long	theCommand);
	void			DoKeyDown(char theChar, Byte keyCode, EventRecord *macEvent);
	Boolean			BecomeGopher(Boolean fBecoming);

protected:

	Boolean			fBorderVisible : 1;			// TRUE if border is visible

	virtual void 	MakeBorder(void);
};

/* Change propagation constants for CDialogText */

enum
{
			/* indicates border may need changing */
			/* info parameter is whether borders should be visible	*/
	NeoDialogBordersChanged	= 100
};

