/******************************************************************************
 CNeoPopupPane.h

		Interface for the CNeoPopupPane Class

		Copyright  1991 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#define _H_CNeoPopupPane

#include <CStdPopupPane.h>
#include <CPopupMenu.h>

enum {
	neoPopupChanged = bureaucratLastChange + 1 };

class CNeoPopupPane : public CStdPopupPane
{
public:
	void 			INeoPopupPane(short menuID, CView *anEnclosure, CBureaucrat *aSupervisor,
								  short aWidth, short aHeight, short aHEncl, short aVEncl,
								  short aTitleGap);
	virtual short	GetCheckedItem(void);
	void			ProviderChanged(CCollaborator *aProvider, long reason, void *info);
	virtual void	SelectItem(short itemNum, tPMSelectAction actionType);

protected:
	short	fTitleGap;
	short	fCurrentItem;

	virtual void 	CalcDimensions(void);
	virtual void 	DoClick(Point hitPt, short modifierKeys, long when);
	virtual void 	MakePopupBox(void);
};
