/****
 * CNDImageGIF.c
 *
 *	Methods for a persistent GIF image type.
 *
 *  Copyright  1992 NeoLogic Systems.  All rights reserved.
 *
 ****/

#include "NeoTypes.h"
#include "CNDImageGIF.h"

// Return the class ID for this kind of object
NeoID CNDImageGIF::getClassID(void) const
{
	return kNDImageGIFID;
}

/*
 * Allocate and initialize a new instance.
 */
CNeoPersist *CNDImageGIF::New(void)
{
	CNDImageGIF *	object;

	object = new CNDImageGIF;

	return object;
}

void CNDImageGIF::draw(Rect *aRect)
{
	PicHandle	pict;

	NeoFailNil(pict = (PicHandle)getBlob());

	DrawPicture(pict, aRect);
}

